"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _types = require("./types");

var _icon = _interopRequireDefault(require("ant-design-vue/es/icon"));

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  name: 'ELoading',
  props: _types.LoadingProps,
  computed: {
    modeMap: function modeMap() {
      return _types.LOADING_MODE[this.mode];
    },
    modeIcon: function modeIcon() {
      if (this.modeMap) {
        return this.modeMap.icon;
      }

      return 'loading';
    },
    modeText: function modeText() {
      if (this.text) {
        return this.text;
      }

      if (this.modeMap) {
        return this.modeMap.text;
      }

      return '加载中...';
    }
  },
  render: function render() {
    var h = arguments[0];
    var iconColor = {
      color: this.$props.color
    };
    var spanClass = "loading-text ".concat(this.$props.mode);
    return h("div", {
      "class": "flex-v flex-hc flex-vc loading-component-wrapper"
    }, [h(_icon["default"], {
      attrs: {
        type: this.modeIcon
      },
      "class": "loading-icon",
      style: iconColor
    }), h("span", {
      "class": spanClass
    }, [this.modeText])]);
  }
};
exports["default"] = _default;